package hiit.blackboard;

import java.util.Vector;

import hiit.blackboard.event.Event;
import hiit.blackboard.event.EventData;

public interface Blackboard {
    
 //   public void registerProducer(Customer prod, CustomerInfo info);
    public void registerProducer(Customer prod, CustomerInfo info, String[] events);
    
    public void removeProducer(Customer prod);
    
    //public void registerEvent(Event e);
    //public void unregisterEvent(Event e);
    
    public Vector getProducerEventList(Customer prod);
    public Vector getEventList();
    
    public void announceInfo(Customer prod, CustomerInfo pi);
    
//    public void pushData(Customer prod, CustomerData data);
    public void pushData(Customer prod, CustomerData data, EventData[] eventData);
    
    public Customer[] getProducers();
    
    /*Taru-->*/
    public String getUsername();
    public void setUsername(String username);
    public String getBTAddress();
    public void setBTAddress(String BTAddress);
    public int getSessionId();
    public void setSessionId(int sessionId);
    /*--> Taru*/
    
    public void subscribeConsumer(Customer cons);
    
    public void unsubscribeConsumer(Customer cons);
    
    public boolean subscribeToProducers(Customer cons, int ctype, int user,
            int custid);
    
    public void subscribeToProducer(Customer cons, Customer prod);
    public void subscribeToEvent(Customer cons, Customer prod, String eventName);
    
    public boolean unsubscribeFromProducers(Customer cons, int ctype, int user,
            int custid);
    
    public void unsubscribeFromProducer(Customer cons, Customer prod);
    
    public CustomerData getData(Customer prod);
    
    /**
     * Requests the Blackboard to fetch new data from a Customer. This might
     * involve the Blackboard telling the Customer to read new data from the
     * data source. Note that the method only returns a boolean describing if
     * new data was produced. If the Customer wants the new data, it needs to
     * fetch it from the Blackboard using the getData() method, or to have been
     * subscribed to the Blackboard before the request for new data.
     * 
     * @param prod
     *            the Customer object in question
     * @return true if new data was produced, false otherwise
     */
    
    public boolean requestNewData(Customer prod);
    
    public CustomerInfo getCustomerInfo(Customer prod);
    
    public boolean setProducerMode(Customer prod, int mode, long timeout);
    
    public void kill();
    
    public void registerEvent(String eventName);
    public void unregisterEvent(String eventName);
    
   // public void subscribeEventToProducer(Event event, Customer prod);
    
   // public void unsubscribeEventFromProducer(Event event, Customer prod);
}
