package hiit.blackboard;

import hiit.BetelgeuseMIDP;
import hiit.logger.Logger;
import hiit.mapper.Properties;

import java.util.Hashtable;
import java.util.Vector;

public class ProducerCache {
	// prod.getInfo().getType() -> Hashtable(paramName, cachedValue)
	private Hashtable producerCache = new Hashtable();
	
	// prod.getInfo().getType() -> Hashtable(paramName, value)
	private Hashtable cachedProducers = new Hashtable();
	
	Logger logger = null;
	public ProducerCache(Logger logger){
		this.logger = logger;
		// add producer/fields
		Hashtable h = new Hashtable();
		h.put("BTDevices", new Integer(1));
		cachedProducers.put(new Integer(Properties.LOCAL_GSM_READER), h);
	}
	
	public CustomerData getUpdated(Customer prod, CustomerData d){
		Integer prodType = new Integer(prod.getInfo().getType());
		
		// if (logger != null) logger.logMessage("Cache getUpdated: " + cachedProducers.containsKey(prodType) + ", type: " + prodType + ", local type: " + new Integer(Properties.LOCAL_GSM_READER) + ", first cache: " + !producerCache.containsKey(prod.toString()) );

		// System.out.println("Cache: " + cachedProducers.containsKey(prodType) + ", type: " + prodType + ", local type: " + new Integer(Properties.LOCAL_GSM_READER) );
		// ignore producer?
		if (!cachedProducers.containsKey(prodType))
			return d;
		
		
		
		if (!producerCache.containsKey(prod.toString())){
			// if (logger != null) logger.logMessage("Cache first cache...");
			
			// first update for producer, cache everything
			Hashtable cache = new Hashtable();
			String[] paramNames = d.getParameterNames();
			Vector[] data = d.getData();
			
			Hashtable prodParamsToBeCached = (Hashtable)cachedProducers.get(prodType);
			for (int i=0; i<paramNames.length; i++){
				
				String name = paramNames[i];
				Vector v = data[i];
				Object value = v.firstElement();
				
				
				// if (logger != null) logger.logMessage("Cache first, na: " + name + "," + value + ", cont: " + prodParamsToBeCached.containsKey(name) );
				
				if (prodParamsToBeCached.containsKey(name)) {
					cache.put(name, value);
				}
			}
			producerCache.put(prod.toString(), cache);
			
			
			
			return d;
		} else {
			Vector updatedParamNames = new Vector();
			Vector updatedParamTypes = new Vector();
			Vector updatedParamValues = new Vector();
			String[] paramNames = d.getParameterNames();
			int[] paramTypes = d.getParameterTypes();
			Vector[] data = d.getData();
			Hashtable cachedParams = (Hashtable)producerCache.get(prod.toString());
			Hashtable prodParamsToBeCached = (Hashtable)cachedProducers.get(prodType);
			
			boolean dataChanged = false;
			boolean cacheUsed = false;
			for (int i=0; i<paramNames.length; i++){
				String name = paramNames[i];
				int type = paramTypes[i];
				Vector v = data[i];
				Object value = v.firstElement();
				
				
				// ignore field?
				boolean cacheField = prodParamsToBeCached.containsKey(name);
				boolean changed = false;
				
				// if (logger != null) logger.logMessage("Cache p: "+ name + ", v: " + value);
				
				if (cacheField){
					cacheUsed = true;
					// check if changed since last update,
					// include only if changed
					Object prevValue = cachedParams.get(name);
					//cachedParams.remove(name);
					// System.out.println("Cache name: " + name + ", val: " + value + ", prevValue: " + prevValue + ", cacheField? " + cacheField);
					// if (logger != null) logger.logMessage("Cache name: " + name + ", val: " + value + ", prevValue: " + prevValue + ", cacheField? " + cacheField);
					
					switch(type){
						case Properties.DATATYPE_STRING:
							// Using String.intern() doesn't seem to be any faster...

							String newStr = value.toString();
							String oldStr = prevValue.toString();
							
							if (newStr.length() != oldStr.length() ) {
								changed = true;
							} else {
								changed = !oldStr.equalsIgnoreCase(newStr);
							}
							break;
						case Properties.DATATYPE_INT:
							
							break;
						case Properties.DATATYPE_DOUBLE:
							
							break;
					}
				}
				
				// System.out.println("Cache cacheField: "+ cacheField + ", changed: " + changed );
				// if (logger != null) logger.logMessage("Cache cacheField: "+ cacheField + ", changed: " + changed);
				
				if (!cacheField || cacheField && changed) {
					updatedParamNames.addElement(name);
					updatedParamTypes.addElement(new Integer(type));
					
					Vector tmp = new Vector();
					tmp.addElement(value);
					updatedParamValues.addElement(tmp);
					
					if (cacheField && changed){
						if (cachedParams.containsKey(name))
							cachedParams.remove(name);
						
						cachedParams.put(name, value);
						
						
						// System.out.println("Cache: update");
						// if (logger != null) logger.logMessage("Cache updateCache: " + name + ", v: " + value);
						
					}
					if (cacheField)
						dataChanged = true;
					
				}
			}
			
			// System.out.println("Cache dataChanged: "+ dataChanged + ", cacheUsed: " + cacheUsed );
			// if (logger != null) logger.logMessage("Cache dataChanged: "+ dataChanged + ", cacheUsed: " + cacheUsed );
			
			if (!cacheUsed) {
				return d;
			} else {
				if (producerCache.containsKey(prod.toString()))
					producerCache.remove(prod.toString());
				
				producerCache.put(prod.toString(), cachedParams);
				
				
				int updatedCnt = updatedParamNames.size();
	
				// System.out.println("Cache: build new data");
				// if (logger != null) logger.logMessage("Cache: build new data");
				
				// create new Customerdata
				String[] paramNamesNew = new String[updatedCnt];
				int[] paramTypesNew = new int[updatedCnt];
				Vector[] paramValuesNew = new Vector[updatedCnt];
				for (int i=0; i<paramNamesNew.length; i++){
					paramNamesNew[i] = (String)updatedParamNames.elementAt(i);
					paramTypesNew[i] = ((Integer)updatedParamTypes.elementAt(i)).intValue();
					paramValuesNew[i] = (Vector)updatedParamValues.elementAt(i);
					
					// System.out.println("Cache " + paramNamesNew[i] + ", " + paramValuesNew[i] );
					// if (logger != null) logger.logMessage("Cache " + paramNamesNew[i] + ", " + paramValuesNew[i] );
					
				}
				CustomerInfo info = prod.getInfo();
				CustomerInfo newInfo = new CustomerInfo(info.getName(), info.getType(), info.getUser(), info.getAddress(), info.getMode(), info.getTimeout(), paramNamesNew, paramTypesNew, info.isInternal());

				
				CustomerData dataNew = new CustomerData(paramValuesNew, d.getTimestamp(), newInfo);
				
				return dataNew;
			}
		}
	}
	public static CustomerData extractParameters(CustomerData cd, String[] includeParameterNames, int[] includeParameterTypes){
		try {
			CustomerInfo info = cd.getInfo();
			CustomerInfo newInfo = new CustomerInfo(info.getName(), info.getType(), info.getUser(), info.getAddress(), info.getMode(), info.getTimeout(), includeParameterNames, includeParameterTypes, info.isInternal());
			
			Vector[] newParamValues = new Vector[includeParameterNames.length];
			
			String[] params = cd.getParameterNames();
			Vector[] data = cd.getData();
			int cnt = 0;
			for (int i=0; i<params.length; i++){
				String name = params[i];
				for (int j=0; j<includeParameterNames.length; j++){
					String incName = includeParameterNames[j];
					if (name.equalsIgnoreCase(incName)){
						newParamValues[cnt++] = data[i];
						break;
					}
				}
			}
			CustomerData dataNew = new CustomerData(newParamValues, cd.getTimestamp(), newInfo);
			return dataNew;
		} catch (Exception e){
			BetelgeuseMIDP.logger.logMessage("ProdCache, etractByName ERR: " + e);
			return cd;
		}
	}
	public static CustomerData extractParametersByPosition(CustomerData cd, String[] includeParameterNames, int[] includeParameterPositions, int[] includeParameterTypes){
		try {
			CustomerInfo info = cd.getInfo();
			CustomerInfo newInfo = new CustomerInfo(info.getName(), info.getType(), info.getUser(), info.getAddress(), info.getMode(), info.getTimeout(), includeParameterNames, includeParameterTypes, info.isInternal());
			
			Vector[] newParamValues = new Vector[includeParameterPositions.length];
			Vector[] data = cd.getData();
			for (int i=0; i<includeParameterPositions.length; i++){
				int pos = includeParameterPositions[i];
				newParamValues[i] = data[pos];
			}
			CustomerData dataNew = new CustomerData(newParamValues, cd.getTimestamp(), newInfo);
			return dataNew;
		} catch (Exception e){
			BetelgeuseMIDP.logger.logMessage("ProdCache, etractByPos ERR: " + e);
			return cd;
		}
	}
	
	// this is used to pass param-positions to ProducerCache.extractParametersByPosition
	public static int[] getParameterPositionsByName(String paramNames[], String includeParamNames[]) {
		int positions[] = new int[includeParamNames.length];
		for (int i=0; i<positions.length; i++){
			String name = includeParamNames[i];
			for (int j=0; j<paramNames.length; j++){
				String paramName = paramNames[j];

				if (name.equalsIgnoreCase(paramName)) {
					positions[i] = j;
					break;
				}
			}
		}
		return positions;
	}
	
	
	/*
	public void printData(CustomerData cd){
		if (logger != null){
			String[] names = cd.getParameterNames();
			Vector[] data = cd.getData();
	
			// logger.logMessage("Cache, print data: " + names.length);
			for (int i=0; i<names.length; i++){
				Vector v = data[i];
				Object value = v.firstElement();
				// logger.logMessage("p: " + names[i] + ": " + value);
			}
		}
	}
	*/
}
