package hiit.blackboard.event;

import hiit.blackboard.CustomerData;
import hiit.blackboard.filter.Filter;

public class EventData {
	public static final int TYPE_INT = 1;
	public static final int TYPE_FLOAT = 2;
	public static final int TYPE_STRING = 3;
	
	
	private String name;
	private int int_val = 0;
	private double double_val = 0;
	private String string_val = "";
	
	private int type;
	private Filter filter;
	
	public EventData(String name, int value, Filter filter){
		this.name = name;
		this.int_val = value;
		type = EventData.TYPE_INT;
		this.filter = filter;
	}
	public EventData(String name, double value, Filter filter){
		this.name = name;
		this.double_val = value;
		type = EventData.TYPE_FLOAT;
		this.filter = filter;
	}
	public EventData(String name, String value, Filter filter){
		this.name = name;
		this.string_val = value;
		type = EventData.TYPE_STRING;
		this.filter = filter;
	}
	
	public void setEventName(String name){
		this.name = name;
	}
	public void setValue(int value){
		this.int_val = value;
	}
	public void setValue(double value){
		this.double_val = value;
	}
	public void setFilter(Filter f){
		this.filter = f;
	}
	
	public String getName(){
		return this.name;
	}
	
	public int getIntValue(){
		return int_val;
	}
	public double getDoubleValue(){
		return double_val;
	}
	public int getType(){
		return type;
	}
	public Filter getFilter(){
		return filter;
	}
	
	

}
