package hiit.blackboard.filter;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import hiit.blackboard.Blackboard;
import hiit.blackboard.Customer;
import hiit.blackboard.CustomerData;
import hiit.blackboard.CustomerInfo;
import hiit.blackboard.event.EventData;
import hiit.logger.Logger;

public class AverageFilter extends Filter {
	//private Vector producers = new Vector();
	private Hashtable weights = new Hashtable();

	private Hashtable updated;
	private int updatedCnt;
	private boolean useEvents;
	private Logger logger;
	
	public AverageFilter(Customer cons, Logger logger) {
		super(null, cons);
		this.logger = logger;
		
		updated = new Hashtable();
		updatedCnt = 0;
		
		//reset();
	}
	
	public void addProducer(String eventName, double weight){
		if (!weights.contains(eventName)){
			//producers.addElement(producer);
			weights.put(eventName, new Double(weight));
		}
		
	}

	public void newData(Customer prod, CustomerData pd, EventData evData) {
		if (this.timeToBroadcast(prod, pd, evData))
			broadcast();
	}
	
	private void broadcast() {
		
		double sum = 0;
		CustomerData pd = null;
		for (Enumeration e = updated.elements(); e.hasMoreElements();) {
			Object[] obj = (Object[]) e.nextElement();
			Customer prod = (Customer) obj[0];
			pd = (CustomerData) obj[1];
			EventData ev = (EventData) obj[2];
			double priority = ((Double)weights.get(ev.getName())).doubleValue();
			double val = ev.getType() == EventData.TYPE_INT ? ev.getIntValue() : ev.getDoubleValue();
			sum += (val*priority);
		}
		sum = sum/updated.size();
		this.consumer.newData(this, pd, new EventData("average", sum, this));
	}
	
	private boolean timeToBroadcast(Customer prod, CustomerData pd, EventData evData){
		if (evData == null)
			return false;
		
		Object key = evData.getName();
		 
		if (updated.containsKey(key)){
			updated.remove(prod);
		} else {
			updatedCnt++;
		}
		
		
		updated.put(key, new Object[] {prod, pd, evData} );
		return (updatedCnt >= weights.size());
	}

	public CustomerInfo getInfo() {
		return null;
	}

	public boolean requestData() {
		return false;
	}

	public boolean setProducerMode(int mode, long timeout) {
		return false;
	}

	public void updateCustomerInfo(Blackboard bb, Customer c, CustomerInfo pi) {
	}

	public void updateProducerList(Blackboard bb, Vector producers) {
	}

}
