package hiit.blackboard.filter;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import hiit.blackboard.Blackboard;
import hiit.blackboard.Customer;
import hiit.blackboard.CustomerData;
import hiit.blackboard.CustomerInfo;
import hiit.blackboard.event.EventData;
import hiit.logger.Logger;

public class CombinatorFilter extends Filter {
	private Customer producers[] = null;
	private Hashtable updated;
	private int updatedCnt;
	private boolean useEvents;
	private Logger logger;
	
	public CombinatorFilter(Customer cons, boolean useEvents, Logger logger) {
		super(null, cons);
		this.useEvents = useEvents;
		this.logger = logger;
		reset();
	}
	
	public void setProducers(Customer[] producers){
		this.producers = producers;
	}
	private void reset(){
		updated = new Hashtable();
		updatedCnt = 0;
	}
	public void newData(Customer prod, CustomerData pd, EventData evData) {
		if (this.timeToBroadcast(prod, pd, evData))
			broadcast();
	}
	
	public void newData(Customer prod, CustomerData pd) {
		if (this.timeToBroadcast(prod, pd, null))
			broadcast();
	}
	
	private void broadcast(){
		 for (Enumeration e = updated.elements() ; e.hasMoreElements() ;) {
			 Object[] obj = (Object[])e.nextElement();
			 Customer prod = (Customer)obj[0];
			 CustomerData pd = (CustomerData)obj[1];
			if (useEvents){
				 EventData ev = (EventData)obj[2];
				 this.consumer.newData(prod, pd, ev);
			} else {
				this.consumer.newData(prod, pd);
			}
	     }
		 reset();
	}
	private boolean timeToBroadcast(Customer prod, CustomerData pd, EventData evData){
		Object key;
		if (evData == null) {
			key = prod.toString();
		} else {
			String evName = evData.getName();
			key = evName;
		}
		
		 
		if (updated.containsKey(key)){
			updated.remove(prod);
		} else {
			updatedCnt++;
		}
		
		logger.logMessage("combi: " + prod + "," + updated + "/" + producers.length);
		
		updated.put(key, new Object[] {prod, pd, evData} );
		return (updatedCnt >= producers.length);
		
		
		
	}

	public CustomerInfo getInfo() {
		return null;
	}

	public boolean requestData() {
		return false;
	}

	public boolean setProducerMode(int mode, long timeout) {
		return false;
	}

	public void updateCustomerInfo(Blackboard bb, Customer c, CustomerInfo pi) {
	}

	public void updateProducerList(Blackboard bb, Vector producers) {
	}

}
