package hiit.blackboard.filter;

import java.util.Vector;

import hiit.blackboard.Blackboard;
import hiit.blackboard.Customer;
import hiit.blackboard.CustomerData;
import hiit.blackboard.CustomerInfo;
import hiit.blackboard.event.EventData;

public class DelayFilter extends Filter {
	private int delay;
	private long lastTime;
	
	public DelayFilter(Customer prod, Customer cons, int delay) {
		super(prod, cons);
		this.delay = delay;
		this.lastTime = System.currentTimeMillis();
	}


	public void newData(Customer prod, CustomerData pd, EventData evData) {
		if (this.timeToBroadcast())
			this.consumer.newData(prod, pd, evData);
	}
	
	public void newData(Customer prod, CustomerData pd) {
		if (this.timeToBroadcast())
			this.consumer.newData(prod, pd);
	}
	private boolean timeToBroadcast(){	
		long now = System.currentTimeMillis();
		if (now > lastTime+delay ){
			lastTime = now;
			return true;
		} else {
			return false;
		}
	}

	
	

	public CustomerInfo getInfo() {
		return null;
	}

	public boolean requestData() {
		return false;
	}

	public boolean setProducerMode(int mode, long timeout) {
		return false;
	}

	public void updateCustomerInfo(Blackboard bb, Customer c, CustomerInfo pi) {
	}

	public void updateProducerList(Blackboard bb, Vector producers) {
	}

}
