package hiit.blackboard.filter;

import java.util.Vector;

import hiit.blackboard.Blackboard;
import hiit.blackboard.BlackboardFactory;
import hiit.blackboard.Customer;
import hiit.blackboard.CustomerData;
import hiit.blackboard.CustomerInfo;
import hiit.blackboard.event.EventData;
import hiit.logger.Logger;

public class ScaleFilter extends Filter {
	private int int_min_limit;
	private int int_max_limit;

	private double double_min_limit;
	private double double_max_limit;

	
	private int int_history = 0;
	private double double_history = 0;
	
	private boolean keepHistory;
	
	private int type;

	public static final int TYPE_INT = 1;
	public static final int TYPE_DOUBLE = 2;
	
	
	public ScaleFilter(Customer prod, Customer cons, int min_limit, int max_limit) {
		super(prod, cons);
		
		
		this.type = TYPE_DOUBLE;
		this.int_min_limit = min_limit;
		this.int_max_limit = max_limit;
	}
	public ScaleFilter(Customer prod, Customer cons, double min_limit, double max_limit) {
		super(prod, cons);
		
		
		this.type = TYPE_DOUBLE;
		this.double_min_limit = min_limit;
		this.double_max_limit = max_limit;
	}
	
	public void newData(Customer prod, CustomerData pd, EventData eventData) {
		// System.out.println("ScaleF newData prod: " + prod + ", evData: " + eventData);
		//if (logger != null) logger.logMessage("GreaterFilter: newData" + eventData );

		//Object val = eventData.getValue();
		boolean send = false;
		EventData newEventData = null;
		double perc = 0;
		double val = 0;
		try {
			switch (eventData.getType()){
			case EventData.TYPE_INT:
				val = (double)eventData.getIntValue();
				perc = (val-int_min_limit) / (int_max_limit-int_min_limit);
				newEventData = new EventData(eventData.getName(), perc, this);
				
				break;
				
			case TYPE_DOUBLE:
				val = eventData.getDoubleValue(); 
				perc = (val-double_min_limit) / (double_max_limit-double_min_limit);
				
				newEventData = new EventData(eventData.getName(), perc, this);
				
				break;
			}
		} catch (Error e){
			System.out.println(this + ": newData: "+ e);
		}
		
		//if (logger != null) logger.logMessage("GreaterFil send?: " + send + ", prod: " + prod + ", cons: " + this.consumer);
		this.consumer.newData(prod, pd, newEventData);
	}
	
	/*
	public void setLimits(Object min_limit, Object max_limit){
		switch (type){
		case TYPE_INT:
			int_min_limit = ((Integer)min_limit).intValue() ;
			int_max_limit = ((Integer)max_limit).intValue() ;

			break;
		case TYPE_DOUBLE:
			double_min_limit = ((Double)min_limit).doubleValue() ;
			double_min_limit = ((Double)min_limit).doubleValue() ;

			break;
		}
	}*/

	public CustomerInfo getInfo() {
		return null;
	}

	public boolean requestData() {
		return false;
	}

	public boolean setProducerMode(int mode, long timeout) {
		return false;
	}

	public void updateCustomerInfo(Blackboard bb, Customer c, CustomerInfo pi) {
	}

	public void updateProducerList(Blackboard bb, Vector producers) {
	}

}
