package hiit.blackboard.httpd;

import hiit.logger.Logger;

//import java.util.Hashtable;
import java.util.Vector;

/*
 *  Class returning json-data as a javascript-variable to requests with path /context. Also returning json-data for 
 *  capella with username and bluetoothaddress. 
 */
public class ContextFetcherComponent implements HttpComponent{
	
	Logger logger = null;
	
	public ContextFetcherComponent(Logger logger){
		this.logger = logger;
	}

	public HttpResponse getReply(HttpRequest request) {
		if(this.logger != null) logger.logMessage("[CFC] Got request.");
		//System.out.println("kutsu");
		//String type="";
		String data="";
		
		//int index=0;
		//Hashtable ht = request.getQueryParameters();   //finding the parameters (not used now, the html form HTTPServer is not valid, so no html-requests now)	
		HttpServer server = HttpServerFactory.getHttpServer(null);  
		Vector prods = server.getAllProducers();  //getting all attached data producers
		
		//this is only needed, if type is given as parameter
		/*if(ht.size()>0){
			try{
		      type = (String) ht.get("type");
			}catch(NullPointerException npe){
				npe.printStackTrace();
				type="";
			}*/
			/*try{
		        index = Integer.parseInt((String)ht.get("ind"));
		        if(this.logger != null) logger.logMessage("[CFC] parsittu indeksi"+index+":"+ prods.size());
			}catch(Exception e){
				if(this.logger != null) logger.logMessage("[CFC] integer: "+e.getMessage());
			}*/
	    //}
		String response="";
		String capella = request.getPath().toString().substring(1);  //is it capella asking?
		//getting context-data
		if(/*type.length()==0 &&*/ !capella.equals("capella")){
			//data = server.getSingleProducerDataAsJson(prods, index);
			//System.out.println("ei capella");
			response ="var data=";
			data = server.getProducerDataAsJson(prods);    
			//removing all chars that violate javascript notation
			/*while(data.indexOf('\'')!=-1){
				data = data.replace('\'', ' ');
			}
			*/
			/*while(data.indexOf('"')!=-1){
		        data= data.replace('"', '\'');	
		    }*/
		}/*else{   //as HTML
		    data ="\""+ server.getProducerData(prods)+"\"";
		}*/
		else{   //capella asking for data
			//System.out.println("capella");
			data = server.getUsernameAndDataAsJson(prods);
		}
		
		//removing all chars that violate javascript notation
		while(data.indexOf('\'')!=-1){
			data = data.replace('\'', ' ');
		}
	    /*while(data.indexOf('"')!=-1){
	        data= data.replace('"', '\'');	
	    }*/
	    while(data.indexOf('\n')!=-1){
	    	   data= data.replace('\n', ' ');
	    }
	    //adding fetched data to response
		response = response+data;
		if(!capella.equals("capella")){
			response = response +";";
		}
		//System.out.println("response:"+response);
		HttpResponse hr = new HttpResponse(response);
		if(!capella.equals("capella")){
			//context data returned as javascript
			hr.setContentType("text/javascript");
		}/*else{
			//for capella the data is returned as json
			hr.setContentType("text/xml");
		}*/
//		System.out.println("response: "+response);
		if(this.logger != null) logger.logMessage("[CFC] data fetched and returned"+response);
		return hr;
	}

	public Path[] getWatchedPaths() {
		//this class is handling requests to paths /context and /capella
		Path p = new Path("context");
		Path p2 = new Path("capella");
		Path[] paths = {p, p2};
		return paths;
	}	
}
