package hiit.connection;

import java.io.InputStream;
import java.io.OutputStream;

/**
 * A generic Connection (outbound socket) interface. Implemented by
 * MIDPConnection and PCConnection.
 * 
 * @author Eemil Lagerspetz
 * 
 */
public interface Connection {
    /**
     * Returns an InputStream from this Connection.
     * 
     * @return an InputStream from this Connection.
     */
    public InputStream getIs();
    
    /**
     * Returns an OutputStream into this Connection.
     * 
     * @return an OutputStream into this Connection.
     */
    public OutputStream getOs();
    
    /**
     * Terminates the connection.
     * 
     */
    public void close();
    
}
