package hiit.connection;

import hiit.logger.Logger;

import java.io.IOException;

import javax.microedition.io.Connector;
import javax.microedition.io.ServerSocketConnection;

public class MIDPServer implements ServerConnection {
    
    private int portnum = 0;
    
    private ServerSocketConnection ss;
    
    private Logger logger;
    
    public MIDPServer(Logger logger) {
        this.portnum = 0;
        this.ss = null;
        this.logger = logger;
    }
    
    private MIDPServer(int portnum) {
        this.portnum = portnum;
        init();
    }
    
    private void init() {
        try {
            ss = (ServerSocketConnection) Connector
                    .open("socket://:" + portnum);
        } catch (IOException e) {
            logger.logMessage("Could not listen on port " + portnum);
            
        }
    }
    
    public Connection accept() {
        try {
            return new MIDPConnection(ss.acceptAndOpen());
        } catch (IOException e) {
            logger.logMessage("Unable to accept a connection to " + portnum);
        }
        return null;
    }
    
    public void close() {
        try {
            ss.close();
        } catch (IOException e) {
            // Nothing we can do
        }
    }
    
    public ServerConnection open(int portnum) {
        ServerConnection s = new MIDPServer(portnum);
        return s;
    }
    
}
