package hiit.connection;

/**
 * A generic ServerConnection (listening socket) interface. Implemented by
 * MIDPServer and PCServer.
 * 
 * @author Eemil Lagerspetz
 * 
 */
public interface ServerConnection {
    /**
     * Creates a new instance listening on the specified port.
     * 
     * @param portnum
     *            The port number to listen on.
     */
    public ServerConnection open(int portnum);
    
    /**
     * Accepts a connection to the listening port, and returns the connection.
     * 
     * @return a Connection that was established on the listening port.
     */
    public Connection accept();
    
    /**
     * Terminates the connection.
     * 
     */
    public void close();
}
