package hiit.logger;

import hiit.util.FileUtil;

import java.io.IOException;
import java.util.Enumeration;
import java.io.OutputStream;
import java.io.PrintStream;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;
import javax.microedition.io.file.FileSystemRegistry;

public class FileLogger extends MIDPLogger {
	private String url;
	private FileConnection fc;
	private OutputStream out;
	private PrintStream printout;
	private boolean streamOpen;
	
	public static final String FILENAME = "btg.log";
	public static final int DEFAULT_LOGLENGTH = 30;
	
	public FileLogger() {
		this(DEFAULT_LOGLENGTH);
	}
	
	public FileLogger(int loglength) {
		// initialize stuff for log UI
		super(loglength);
		
		// open the actual log file for writing
		try {
			this.url = FileUtil.composeFilePath(FILENAME);
			this.logMessage("[FileLogger] Using url: " + url);

			//Open the file
			this.fc = (FileConnection)Connector.open(url);
			//Ok... Now we have a connection, but the file might not exists (doh!). Check the existence and create a file if needed
			if(!this.fc.exists())
				this.fc.create();
			//Yikes... There isn't a write method that appends data to the end of the file, so we need to open the
			//outputstream to a specific location inside the file
			long size = this.fc.fileSize();
			if(size == -1)
				this.out = this.fc.openOutputStream();
			else
				this.out = this.fc.openOutputStream(size);

			if(out == null){
				this.logMessage("[FileLogger]Output stream is null.");
			}else
				this.streamOpen = true;
			
			if (this.streamOpen) {
				this.printout = new PrintStream(out);
			} else {
				this.printout = null;
			}
				
		}catch (IOException e){
			this.logMessage("[FileLogger]Could not open the output file: " + this.FILENAME + "\n" + e.toString());
		}
	}

	public void clearLog() {
		// TODO Auto-generated method stub

	}

	public void flushLog() {
		// TODO Auto-generated method stub

	}

	public void logMessage(String message) {
		// log in UI
		super.logMessage(message);
		
		// append to file
		if (this.printout != null) {
			this.printout.print(message + "\n");
			this.printout.flush();
		}

	}

	public void outputLog() {
		// TODO Auto-generated method stub

	}

}
