/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package hiit.mapper;

import javax.microedition.rms.RecordComparator;

/**
 * This class is used to compare records which are fetched from
 * MIDP RecordStore.
 * @author Joonas Kukkonen and Eemil Largerspetz
 *
 */

public class MIDPRecordComparator implements RecordComparator {

	/**
	 * Compares two byte arrays.
	 * @see javax.microedition.rms.RecordComparator#compare(byte[], byte[])
	 */
	
	public int compare(byte[] arg0, byte[] arg1) {
		for (int i = 0; i < arg0.length && i < arg1.length; i++){
				if (arg0[i] < arg1[i])
					return RecordComparator.PRECEDES;	
				if (arg0[i] > arg1[i])
					return RecordComparator.FOLLOWS;
		}
		return RecordComparator.EQUIVALENT;
	}

}
