/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package hiit.midpgui;

import javax.microedition.lcdui.Graphics;

import java.util.Enumeration;
import java.util.Hashtable;
/**
 * @author Petteri Nurmi
 */
public class InformationContainer extends TabCanvasItem{

	//private VerticalScrollBar _scrollBarv = new VerticalScrollBar(); 
	private Hashtable _objects = new Hashtable();
	private TabPane _tabPane;
	
	public InformationContainer(TabPane _tabPane) {
		this._tabPane = _tabPane;
	}
	
	public void addInformationObject(InformationObject _io) {
		Tab _t = _tabPane.createTab(_io);
		_objects.put(_t,_io);
	}
	
	public void removeInformationObject(InformationObject _io) {
		Enumeration en = _objects.keys();
		while(en.hasMoreElements()){
			Object o = en.nextElement();
			if (_objects.get(o) == _io)
			_tabPane.removeTab((Tab)o);
		}
		if (_objects.contains(_io)){
			_objects.remove(_io);
		}
	}
	
	public void scrollUp() {
		Tab _t = _tabPane.getActiveTab();
		InformationObject _io = (InformationObject)_objects.get(_t);
		_io.scrollUp();
	}
	
	public void scrollDown() {
		Tab _t = _tabPane.getActiveTab();
		InformationObject _io = (InformationObject)_objects.get(_t);
		_io.scrollDown();
	}
	
	protected void draw(Graphics g, int x0, int y0, int width, int height) {
		// Reserve 10% for scrollbar
		g.setClip(x0,y0,width,height);
		g.setColor(255,255,255);
		g.fillRect(x0,y0,width,height);
		
		//Since the scrollbar doesn't animate on every mobile phone, don't draw it
		//int wscroll = (int)(width * 0.10);
		//int hscroll = (int)(height * 0.075);
		//_scrollBarv.draw(g,width - wscroll,y0,wscroll,height);
		
		Tab _t = _tabPane.getActiveTab();
		if (_t != null){
			InformationObject _io = (InformationObject)_objects.get(_t);
			//_io.draw(g,x0,y0,width-wscroll,height);
			_io.draw(g,x0,y0,width,height);
		}
	}	
	
}
