/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package hiit.midpgui;

//import javax.microedition.lcdui.Font;

import javax.microedition.lcdui.Graphics;
import hiit.reader.Reader;
/**
 * @author Petteri Nurmi
 */
public class ReaderInformationObject extends InformationObject{
	
	private int currentMinVisible = 0; 
	private String[] parameterNames;
	private Reader reader;
	
	public ReaderInformationObject(Reader reader) {
		super(reader.getDeviceName());
		this.reader = reader;
		this.parameterNames = reader.getParameterNames();
	}

	protected void draw(Graphics g, int x0, int y0, int width, int height) {
		g.setClip(x0,y0,width,height);
		g.setColor(255,255,255);
		g.fillRect(x0,y0,width,height);		
		//g.setColor(155,155,215);
		g.setColor(50,50,180);
		//g.setFont(Font.getFont(g.getFont().getFace(),g.getFont().getStyle(),Font.SIZE_LARGE));
		int _fontSize = g.getFont().getHeight();

		int y1 = y0 + 5;
		for (int i = 0; i < this.parameterNames.length; i++) {
			//if(index>=currentMinVisible && index<=(currentMinVisible+maxParams)) {
			if(i>=currentMinVisible) {
				
				String value = this.reader.getParameter(this.parameterNames[i]);
				
				g.drawString(this.parameterNames[i] + ": ",x0+10,y1,0);
				y1 += (_fontSize + 5);
				
				//g.drawString(value,x0+20,y1,0);
				//y1 += (_fontSize + 10);
				
				int spot = -1;
				while((spot = value.indexOf("\n")) > -1){
					String line = value.substring(0, spot);
					value = value.substring(spot + 1);
					
					if (line != ""){
						g.drawString(line, x0+20, y1, 0);
						y1 += _fontSize;
					}
				}
				
				if (value != ""){
					g.drawString(value, x0+20, y1, 0);
					y1 += _fontSize;
				}
				y1 += (_fontSize);
			}
			if (y1 > y0 + height)
				break;

			//++index;
		}
	}		

	protected void scrollUp() {
		if(currentMinVisible>0)
			--currentMinVisible;		
	}

	protected void scrollDown() {
		
		//if(currentMinVisible<this.parameterNames.length-maxParams)
		if(currentMinVisible<this.parameterNames.length-1)
			
			++currentMinVisible;
	}
	
}
