/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package hiit.midpgui;

import javax.microedition.lcdui.Graphics;
/**
 * @author Petteri Nurmi
 */
public abstract class ScrollBar extends TabCanvasItem {
	
	protected int _minValue = 0;
	protected int _maxValue = 0;
	protected int _currentValue = 0; 
	
	protected void draw(Graphics g, int x0, int y0, int width, int height) {
		if(_minValue == _maxValue) {			
			drawDisabled(g,x0,y0,width,height);
		}
		else {
			drawEnabled(g,x0,y0,width,height);
		}
	}
	
	public void setMaxValue(int _maxValue) {
		if(_maxValue>0) {
			if(_maxValue<_minValue) {
				this._maxValue=_maxValue;
				this._minValue=_maxValue;				
			}else {
				this._maxValue = _maxValue;
			}
			if(this._currentValue>this._maxValue)
				this._currentValue = this._maxValue;
		}
	}
	
	public void setMinValue(int _minValue) {
		if(_minValue>0) {
			if(_minValue<_maxValue) {
				this._minValue = _minValue;
				this._maxValue = _minValue;
			}else {
				this._minValue = _minValue;
			}
			if(this._currentValue<this._minValue)
				this._currentValue = this._minValue;
		}
	}
	
	protected abstract void drawEnabled(Graphics g, int x0, int y0, int width, int height);
	protected abstract void drawDisabled(Graphics g, int x0, int y0, int width, int height);

}