/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package hiit.midpgui;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
/**
 * @author Petteri Nurmi
 */
public class Tab extends TabCanvasItem{
	
	private String _title = "";
	private boolean _active = false;
	
	public Tab(String _title) {
		this._title = _title;
	}
	
	public void setActive(boolean active){
		this._active = active;
	}


	protected void draw(Graphics g, int x0, int y0, int width, int height) {
		g.setClip(x0,y0,width,height);
		Font _f = g.getFont();				
		int h5 = (int)(height/20);
		int w5 = (int)(width/20);
		if(_active)
			g.setColor(200,100,100);
		else
			g.setColor(155,155,215);
		if(_f.getHeight()>(height-(2*h5)-5)) {
			switch(_f.getSize()) {
			case Font.SIZE_LARGE:
				g.setFont(Font.getFont(_f.getFace(),_f.getStyle(),Font.SIZE_MEDIUM));
				break;
			case Font.SIZE_MEDIUM:
				g.setFont(Font.getFont(_f.getFace(),_f.getStyle(),Font.SIZE_SMALL));
				break;
			}	
		}
		//g.setFont(Font.getFont(g.getFont().getFace(),g.getFont().getStyle(),Font.SIZE_LARGE));
		if (height-h5-2 < y0+h5+1+2+g.getFont().getSize())
			g.drawRect(x0+1,y0+h5+1,width-2,height-h5-2);
		else
			g.drawRect(x0+1,y0+h5+1,width-2,y0+h5+1+2+g.getFont().getSize());
		//g.setClip(x0+w5,h5,width-w5 - w5,height-h5-h5);
		g.setClip(x0,y0,width-w5,height);
		//g.drawString(_title,x0+w5+1,y0+(height>>1),0);
		//// The original before fix by EL
		//g.drawString(_title,x0+w5+1,y0+h5+1,0);
		//// Fix-attempt
		g.drawString(_title,x0+w5+5,y0+h5+5,0);
	}

}
