/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

package hiit.midpgui;

import javax.microedition.lcdui.Graphics;
/**
 * @author Petteri Nurmi
 */
public class TabHeader extends TabCanvasItem {
	
	private String _title = "";
	
	public TabHeader(String appTitle) {
		_title = appTitle;
	}	

	protected void draw(Graphics g, int x0, int y0, int width, int height) {
		
		g.setClip(x0,y0,width,height);
		g.setColor(255,231,184);
		g.fillRect(x0,y0,width,height);
		//g.setColor(155,155,215);
		//g.setFont(Font.getFont(g.getFont().getFace(),g.getFont().getStyle(),Font.SIZE_LARGE));
		g.setColor(50,50,180);
		if (height > g.getFont().getHeight() + 5)
			g.drawString(_title,x0+(width)>>1,y0+5,0);
		else
			g.drawString(_title,x0+(width)>>1,y0,0);
		//g.drawString(_title,x0+(width)>>1,y0+(height)>>1,0);
		g.drawLine(x0,y0+height,width,y0+height);
	}

}
