/*
 * BeTelGeuse - A context data gathering tool for Bluetooth devices
 * www.cs.helsinki.fi/group/acs/betelgeuse
 * Copyright (C) 2006 Joonas Kukkonen, Eemil Lagerspetz and Petteri Nurmi
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
package hiit.midpgui;


import javax.microedition.lcdui.Graphics;
/**
 * @author Petteri Nurmi
 */
public class VerticalScrollBar extends ScrollBar {
	
	public VerticalScrollBar() {
		this._maxValue = 100;
		this._currentValue = 50;
	}	

	protected void drawEnabled(Graphics g, int x0, int y0, int width, int height) {
		int h = ((height)/13);
		//int h = (int)((0.075 * (height)) //This gives an error about floating points...
		g.setColor(255,231,184);
		g.fillRect(x0,y0+h,width,height - (h<<1));
		
		// Draw the scroll top and bottom indicators and the indicator itself		
		g.setColor(0,0,0);
		g.drawRect(x0,y0,width,h);
		g.drawRect(x0,y0+height-h,width,h);
		g.setColor(155,155,215);
		g.fillRoundRect(x0+1,y0+1,width-2,h-2,1,1);
		g.fillRoundRect(x0+1,y0+height - h+1,width-2,h-2,1,1);
		
	}

	protected void drawDisabled(Graphics g, int x0, int y0, int width, int height) {
		g.setColor(225,225,225);
		g.fillRect(x0,y0,width,height);		
	}
	
}
