package hiit.plugin.activity;

import hiit.plugin.MIDPPlugin;

import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.StringItem;

public class ActivityGUI implements MIDPPlugin, CommandListener {
	
	private ActivityPlugin plugin = null;
	
	private Displayable current = null;
	private Display display = null;
	
	private Form activityScreen = null;
	private Command back = null;
	private Command close = null;
	private StringItem activity = new StringItem("Activity", "");
	private StringItem varsum = new StringItem("Variance sum", "");
	private StringItem xmean = new StringItem("Mean X", "");
	private StringItem ymean = new StringItem("Mean Y", "");
	private StringItem zmean = new StringItem("Mean Z", "");
	private StringItem xvar = new StringItem("Variance X", "");
	private StringItem yvar = new StringItem("Variance Y", "");
	private StringItem zvar = new StringItem("Variance Z", "");
	private StringItem xmax = new StringItem("Max X", "");
	private StringItem ymax = new StringItem("Max Y", "");
	private StringItem zmax = new StringItem("Max Z", "");
	private StringItem xmin = new StringItem("Min X", "");
	private StringItem ymin = new StringItem("Min Y", "");
	private StringItem zmin = new StringItem("Min Z", "");
	
	public ActivityGUI(ActivityPlugin plugin){
		this.plugin = plugin;
		
		this.activityScreen = new Form("Activity plugin");
		this.back = new Command("Back", Command.BACK, 1);
		this.close = new Command("Close", Command.ITEM, 1);
		this.activityScreen.addCommand(back);
		this.activityScreen.addCommand(close);
		this.activityScreen.setCommandListener(this);
		
		this.activityScreen.append(activity);
		this.activityScreen.append("\n");
		this.activityScreen.append(varsum);
		this.activityScreen.append("\n");
		this.activityScreen.append(xmean);
		this.activityScreen.append("\n");
		this.activityScreen.append(ymean);
		this.activityScreen.append("\n");
		this.activityScreen.append(zmean);
		this.activityScreen.append("\n");
		this.activityScreen.append(xvar);
		this.activityScreen.append("\n");
		this.activityScreen.append(yvar);
		this.activityScreen.append("\n");
		this.activityScreen.append(zvar);
		this.activityScreen.append("\n");
		this.activityScreen.append(xmax);
		this.activityScreen.append("\n");
		this.activityScreen.append(ymax);
		this.activityScreen.append("\n");
		this.activityScreen.append(zmax);
		this.activityScreen.append("\n");
		this.activityScreen.append(xmin);
		this.activityScreen.append("\n");
		this.activityScreen.append(ymin);
		this.activityScreen.append("\n");
		this.activityScreen.append(zmin);
	}

	public void close() {
		this.plugin.close();
	}

	public String getName() {
		return "Activity plugin";
	}

	public void showPluginGui(Display display, Displayable current) {
		this.current = current;
		this.display = display;
		display.setCurrent(this.activityScreen);	
	}
	
	public void update(String activity, double[] features){
		this.activity.setText(activity);
		this.varsum.setText("" + (features[3]/4096 + features[4]/4096 + features[5]/4096));
		this.xmean.setText("" + features[0]);
		this.ymean.setText("" + features[1]);
		this.zmean.setText("" + features[2]);
		this.xvar.setText("" + features[3]);
		this.yvar.setText("" + features[4]);
		this.zvar.setText("" + features[5]);
		this.xmax.setText("" + features[6]);
		this.ymax.setText("" + features[7]);
		this.zmax.setText("" + features[8]);
		this.xmin.setText("" + features[9]);
		this.ymin.setText("" + features[10]);
		this.zmin.setText("" + features[11]);
	}

	public void commandAction(Command arg0, Displayable arg1) {
		if(arg0 == this.back)
			this.display.setCurrent(this.current);
		else if(arg0 == this.close){
			this.plugin.close();
			this.display.setCurrent(this.current);
		}
			
	}

}
