package hiit.plugin.activity.feature.periodic;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class SpectralCentroid extends Feature{

    public SpectralCentroid(Module parent) {
        super(parent, "SC");
    }

    protected double[] getFeatResult(Instance[] source) {

        // Create storage
        double [] result = new double[source[0].getDimensionality()];
        
        for (int i = 0; i < result.length; i++){
            double wsum = 0;
            double sum = 0;
            for (int j = 1; j < source.length; j++){
                wsum += source[j].getValues()[i] * j;
                sum += source[j].getValues()[i];
            }
            result[i] = wsum / sum;
        }
            
        // Return results
        return result;
    }

}
