package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.*;
import hiit.plugin.activity.utils.Module;

public class AutoCorrelation extends Feature{

    private int m = 1;
    
	public AutoCorrelation(Module parent) {
		super(parent, "ACORR");
		dependencies = new String[] {"MEAN", "VAR"};
	}
	
	protected double[] getFeatResult(Instance[] source) throws Exception {
        
        // Create storage
	    double[] result = new double[source[0].getDimensionality()];		
		
	    double [] mean = getFeatureValues(dependencies[0]);
	    double [] var = getFeatureValues(dependencies[1]);
	    
        for (int j = 0; j < result.length; j++){
            double sum = 0;
            for(int i=0; i < source.length - m; i++) {
                sum += (source[i].getValues()[j] - mean[j]) * (source[i + m].getValues()[j] - mean[j]);
	        }
            result[j] = sum / (var[j] * (source.length - m));
	    }
        
        // Return results
		return result;
	}

}
