package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class AverageAbsoluteDeviation extends Feature {

	public AverageAbsoluteDeviation(Module parent) {
		super(parent, "AADEV");
		dependencies = new String[] {"MEAN"};
	}

	protected double[] getFeatResult(Instance[] source) throws Exception {
		double[] _mean = getFeatureValues(dependencies[0]);
		
		// Create storage
		double [] result = new double[source[0].getDimensionality()];
		
			// Loop through the values and compute estimate
		for(int i=0;i<source.length;i++) {
			
			// Get the next instance
			final double[] _instanceValues = source[i].getValues();
			
			// Update estimates
			for(int j=0;j<_instanceValues.length;j++) {
				result[j] += Math.abs(_instanceValues[j] - _mean[j]);				
			}
		}				
		
		for(int i=0;i<result.length;i++)
			result[i] /= (double)source.length;
		
		// Return results
		return result;
	}
}
