package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.MathUtils;
import hiit.plugin.activity.utils.Module;

/**
 * Calculates the energy of a signal
 * @author ptnurmi
 *
 */
public class Energy extends Feature {
	
	public Energy(Module parent) {
		super(parent, "ENERGY");
	}

	protected double[] getFeatResult(Instance[] source) throws Exception {

		// Create storage
		double [] result = new double[source[0].getDimensionality()];
				
		// Loop through the values and compute estimate
		for(int i=0;i<source.length;i++) {
							
			// Get the next instance
			final double[] _instanceValues = source[i].getValues();
			
			// Update estimates
			for(int j=0;j<_instanceValues.length;j++) {
			    result[j]+= MathUtils._POW(Math.abs(_instanceValues[j]),2);				
			}
		}
		
		// Return results
		return result;
		
	}

}
