package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class HarmonicMean extends Feature{

    /**
     * Calculates the harmonic mean - see http://en.wikipedia.org/wiki/Harmonic_mean
     */
	public HarmonicMean(Module parent) {
		super(parent, "HMEAN");
	}
	
	protected double[] getFeatResult(Instance[] source) {
		// Create storage
		double[] result = new double[source[0].getDimensionality()];
		
		for (int i = 0; i < result.length; i++){
		    for (int j = 0; j < source.length; j++){
		        result[i] += 1/source[j].getValues()[i];
		    }
		    result[i] = source.length / result[i];
		}
			
		// Return results
		return result;
	}
}
