package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.MathUtils;
import hiit.plugin.activity.utils.Module;

public class Kurtosis extends Feature {

    public Kurtosis(Module parent) {
        super(parent, "KURTOSIS");
        dependencies = new String[] {"MEAN", "STDDEV"};
    }

    protected double[] getFeatResult(Instance[] source) throws Exception {

        double[] _mean = getFeatureValues(dependencies[0]);

        double[] _stdDev = getFeatureValues(dependencies[1]);

        // Create storage
        double [] result = new double[source[0].getDimensionality()];

        // Loop through the values and compute estimate
        for (int i = 0; i < source.length; i++) {

            // Get the next instance
            final double[] _instanceValues = source[i].getValues();

            // Update estimates
            for (int j = 0; j < _instanceValues.length; j++) {

                result[j] += MathUtils._POW(
                        (_instanceValues[j] - _mean[j]) / _stdDev[j], 4);
            }
        }

        for (int i = 0; i < result.length; i++)
            result[i] /= ((double) source.length - 1.0);

        // Return results
        return result;
    }

}
