package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class MeanCrossingRate extends Feature {

    public MeanCrossingRate(Module parent) {
        super(parent, "MCR");
        dependencies = new String[] {"MEAN"};
    }

    protected double[] getFeatResult(Instance[] source) throws Exception {

        // Get the mean
        double[] _mean = getFeatureValues(dependencies[0]);

        // Create storage for results
        double[] result = new double[source[0].getDimensionality()];

        double[] _lastVal = new double[source[0].getDimensionality()];

        _lastVal = source[0].getValues();

        for (int _i = 1; _i < source.length; _i++) {

            final double[] _nextValue = source[_i].getValues();
            for (int _j = 0; _j < _nextValue.length; _j++) {
                if (cross(_lastVal[_j], _nextValue[_j], _mean[_j]))
                    result[_j]++;
            }
            _lastVal = source[_i].getValues();

        }

        return result;
    }

    private final boolean cross(final double _v1, final double _v2,
            final double _c) {
        if (_v1 < _c && _v2 > _c)
            return true;
        if (_v1 > _c && _v2 < _c)
            return true;
        return false;
    }

}
