package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class RootMeanSquare extends Feature  {

	public RootMeanSquare(Module parent) {
		super(parent, "RMS");
	}

    protected double[] getFeatResult(Instance[] source) throws Exception {

		// Create storage
        double[] result = new double[source[0].getDimensionality()];
		
		// Loop through values and compute estimate
		for(int i=0;i<source.length;i++) {
			
			// Get next instance
			final double[] _instanceValues = source[i].getValues();

			// Update estimates
			for(int j=0;j<_instanceValues.length;j++) {
				
				result[j] += (_instanceValues[j] * _instanceValues[j]);
				
			}
			
		}
		
		// Get the results
		for(int j=0;j<result.length;j++) {
			result[j] = Math.sqrt(result[j] / source.length);
		}
		
		// Return results
		return result;
		
	}

}