package hiit.plugin.activity.feature.statistical;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class SignalToNoiseRatio extends Feature {

	public SignalToNoiseRatio(Module parent) {
		super(parent, "SNR");
		dependencies = new String[] {"MEAN", "STDDEV"};
	}

    protected double[] getFeatResult(Instance[] source) throws Exception {

		// Get the mean
		double[] _mean = getFeatureValues(dependencies[0]);
		
		// Get the standard deviation
		double[] _stdev = getFeatureValues(dependencies[1]);
		
		// Create storage for results
		double[] result = new double[source[0].getDimensionality()];
		
		// The SNR is defined as the mean divided by the standard deviation, here we perform this calculation
		for(int j=0;j<result.length;j++) {
		    result[j] = _mean[j] / _stdev[j];
		}
		
		// Return results
		return result;
		
	}
	
	
}
