package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class BowleySkewness extends Feature  {

    public BowleySkewness(Module parent) throws Exception {
        super(parent, "BSKEW");
        dependencies = new String[] {"MEDIAN"};
    }
    
    protected double[] getFeatResult(Instance[] source) throws Exception {
        
        double[] _median = getFeatureValues(dependencies[0]);
        
        double[] result = new double[source[0].getDimensionality()];
        
        final int _n = source.length;
        final int _d = source[0].getDimensionality();
        final int _q1 = (int)Math.floor(0.25 * _n);
        final int _q3 = (int)Math.ceil(0.75 * _n - 1);
        
        result = new double[_d];
        for(int i=0;i<_d;i++) {
                if (Math.abs(source[_q3].getValues()[i] - source[_q1].getValues()[i]) == 0) //NaN prevention
                {
                    if (Math.abs(source[_q1].getValues()[i] - 2 * _median[i] + source[_q3].getValues()[i]) == 0)
                        result[i] = 1;
                    else if ((source[_q1].getValues()[i] - 2 * _median[i] + source[_q3].getValues()[i]) > 0)
                        result[i] = Double.MAX_VALUE;
                    else result[i] = -Double.MAX_VALUE;
                }
                else
                    result[i] = (source[_q1].getValues()[i] - 2 * _median[i] + source[_q3].getValues()[i]) / 
                        (source[_q3].getValues()[i] - source[_q1].getValues()[i]);
        }
        
        return result;
    }
}