package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class InterQuartileMean extends Feature {

    public InterQuartileMean(Module parent) throws Exception {
        super(parent, "IQMEAN");
    }

    protected double[] getFeatResult(Instance[] source) {
        
        double[] result = new double[source[0].getDimensionality()];
        final int _n = source.length;
        final int _d = source[0].getDimensionality();
        final int _q1 = (int) Math.floor(0.25 * _n);
        final int _q3 = (int) Math.ceil(0.75 * _n - 1);

        result = new double[_d];

        for (int i = _q1 + 1; i < _q3; i++) {
            final double[] _nextVal = source[i].getValues();
            for (int j = 0; j < _d; j++) {
                result[j] += _nextVal[j];
            }
        }

        for (int j = 0; j < _d; j++) {
            result[j] = 2.0 / _n * result[j];
        }

        return result;
    }

}
