package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class InterQuartileRange extends Feature {

    public InterQuartileRange(Module parent) {
        super(parent, "IQRANGE");
    }

    protected double[] getFeatResult(Instance[] source) {

        final int _n = source.length;
        final int _d = source[0].getDimensionality();
        final int _q1 = (int) Math.floor(0.25 * _n);
        final int _q3 = (int) Math.ceil(0.75 * _n - 1);

        double [] result = new double[_d];
        for (int i = 0; i < _d; i++) {
            result[i] = (source[_q3].getValues()[i] - source[_q1]
                    .getValues()[i]);
        }

        return result;
    }

}
