package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class Median extends Feature {

	public Median(Module parent) {
		super(parent, "MEDIAN");
	}

    protected double[] getFeatResult(Instance[] source) {

		final int _n = source.length;
		
		int _lowPoint = 0;
		int _highPoint = 0;
		
		if(_n % 2 == 0) {
			_lowPoint = _n / 2 - 1;
			_highPoint = _lowPoint + 1;
		}else {
			_lowPoint = _highPoint = (_n - 1) / 2;
		}
		
		final double[] _dataLow = source[_lowPoint].getValues();
		final double[] _dataHigh = source[_highPoint].getValues();
		
		double [] result = new double[source[0].getDimensionality()];
		
		for(int j=0;j<result.length;j++) {
		    result[j] = (_dataLow[j] + _dataHigh[j]) / 2.0;
		}
		
		return result;
		
	}

}
