package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class MidRange extends Feature {

	public MidRange(Module parent) {
		super(parent, "MIDRANGE");
		dependencies = new String[] {"MIN", "MAX"};
	}
	
    protected double[] getFeatResult(Instance[] source) throws Exception {
        
		final int _d = source[0].getDimensionality();
		
		double[] _min = getFeatureValues(dependencies[0]);
		double[] _max = getFeatureValues(dependencies[1]);
		
		double [] result = new double[_d];
		
		for(int j=0;j<_d;j++)
		    result[j] = (_min[j] + _max[j]) / 2.0;
		
		return result;
		
	}

}
