package hiit.plugin.activity.feature.statistical.sorted;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.utils.Module;

public class Percentile extends Feature {

    private int order = 75;

    public Percentile(Module parent) {
        super(parent, "PERC(75)");
        dependencies = new String[] {"MEDIAN"};
    }

    public Percentile(Module parent, int _order) {
        super(parent, "PERC(50)");
        setOrder(_order);
        setName("PERC(" + _order + ")");
    }

    public void setOrder(int _order) {
        if (_order < 0 || _order > 100)
            return;
        this.order = _order;
    }

    protected double[] getFeatResult(Instance[] source) throws Exception {
        if (order == 50)
            return getFeatureValues(dependencies[0]);
        if (order == 0)
            return source[0].getValues();
        if (order == 100)
            return source[source.length - 1].getValues();
        final int _n = (int) (((source.length - 1) / 100.0 * order) + 0.5);
        double[] result = source[_n].getValues();
        return result;
    }

}
