package hiit.plugin.activity.filter;

import hiit.plugin.activity.data.Instance;

public class MovingAverageFilter implements Filter {
	
	private int _windowSize = 5;
	
	public MovingAverageFilter() {		
	}
	
	public MovingAverageFilter(int _windowSize) {
		this._windowSize = _windowSize;
	}

	public Instance[] applyFilter(Instance[] _signals) {
		
		if(_signals == null)return null;
		
		final int _n = _signals.length;
		if(_n <= 0)return null;
		
		final int _d = _signals[0].getDimensionality();
		if(_d<=0)return null;
		
		Instance[] _newInstances = new Instance[_signals.length];
		
		double[][] _valueMatrix = new double[_n][_d];
		
		for(int _i = 0;_i<_n;_i++) {
			
			int _lowerIndex = Math.max(0, _i - _windowSize);
			
			_valueMatrix[_i] = _signals[_i].getValues();
			double[] _tmpMatrix = new double[_d];
			System.arraycopy(_valueMatrix[_i],0,_tmpMatrix,0,_d);
			
			
			int _counter = 0;
			
			for(int _q = _i - 1; _q > _lowerIndex; _q--) {
				for(int _z = 0;_z<_d;_z++) {
					_tmpMatrix[_z] += _valueMatrix[_i - _q][_z];
				}				
				_counter++;
			}
			
			if(_counter > 0) {
				for(int _z = 0; _z < _d; _z++) {
					_tmpMatrix[_z] /= (1.0 * _counter);
				}
			}
			
			_newInstances[_i] = new Instance(_tmpMatrix);
			
		}
		
		return _newInstances;
		
		//y[n] = 1 / M \sum_{k=0}^{M-1} x[n - k]
	}


}
