package hiit.plugin.activity.preprocessor;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.filter.Filter;

import java.util.Vector;

public class Preprocessor {
	
	private Vector _filters = new Vector();
	
	/**
	 * 
	 * @param _filter
	 */
	public void addFilter(Filter _filter) {
		if(!_filters.contains(_filter)) {
			_filters.addElement(_filter);
		}
	}
	
	/**
	 *
	 * @param _filter
	 */
	public void removeFilter(Filter _filter) {
		if(_filters.contains(_filter)) {
			_filters.removeElement(_filter);
		}
	}
	
	/**
	 * 
	 * @param _instances
	 * @return result
	 */
	public Instance[] preprocess(Instance[] _instances) {
		
		if(_filters.size()>0) {
			
			// Get the number of datapoints as well check for errors
			final int _n = _instances.length;			
			if(_n <= 0)return _instances;
			
			// Get the dimensionality of the data and check for errors
			final int _d = _instances[0].getDimensionality();
			if(_d <=0)return _instances;
			
			// 
			for(int i=0;i<_filters.size();i++) {
				_instances = ((Filter)_filters.elementAt(i)).applyFilter(_instances);
			}
			
			return _instances;
			
		}else 
			return _instances;		
	}

}
