package hiit.plugin.activity.svm;
public class svm_parameter
{
	/* svm_type */
	public static final int C_SVC = 0;
	public static final int NU_SVC = 1;
	public static final int ONE_CLASS = 2;
	public static final int EPSILON_SVR = 3;
	public static final int NU_SVR = 4;

	/* kernel_type */
	public static final int LINEAR = 0;
	public static final int POLY = 1;
	public static final int RBF = 2;
	public static final int SIGMOID = 3;
	public static final int PRECOMPUTED = 4;

	public int svm_type;
	public int kernel_type;
	public int degree;	// for poly
	public double gamma;	// for poly/rbf/sigmoid
	public double coef0;	// for poly/sigmoid

	// these are for training only
	public double cache_size; // in MB
	public double eps;	// stopping criteria
	public double C;	// for C_SVC, EPSILON_SVR and NU_SVR
	public int nr_weight;		// for C_SVC
	public int[] weight_label;	// for C_SVC
	public double[] weight;		// for C_SVC
	public double nu;	// for NU_SVC, ONE_CLASS, and NU_SVR
	public double p;	// for EPSILON_SVR
	public int shrinking;	// use the shrinking heuristics
	public int probability; // do probability estimates

	public Object clone() 
    {
        svm_parameter newSvmPar = new svm_parameter();

        newSvmPar.svm_type = this.svm_type;
        newSvmPar.kernel_type = this.kernel_type;
        newSvmPar.degree = this.degree;  // for poly
        newSvmPar.gamma = this.gamma;    // for poly/rbf/sigmoid
        newSvmPar.coef0 = this.coef0;    // for poly/sigmoid

        // these are for training only
        newSvmPar.cache_size = this.cache_size; // in MB
        newSvmPar.eps = this.eps;  // stopping criteria
        newSvmPar.C = this.C;    // for C_SVC, EPSILON_SVR and NU_SVR
        newSvmPar.nr_weight = this.nr_weight;       // for C_SVC
        newSvmPar.weight_label = new int[this.weight_label.length];
        System.arraycopy(this.weight_label, 0, newSvmPar.weight_label, 0, this.weight_label.length);
        newSvmPar.weight = new double[this.weight.length];
        System.arraycopy(this.weight, 0, newSvmPar.weight, 0, this.weight.length);
        newSvmPar.nu = this.nu;   // for NU_SVC, ONE_CLASS, and NU_SVR
        newSvmPar.p = this.p;    // for EPSILON_SVR
        newSvmPar.shrinking = this.shrinking;   // use the shrinking heuristics
        newSvmPar.probability = this.probability; // do probability estimates
        
        return newSvmPar;
    }

}
