package hiit.plugin.activity.transform;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.utils.Module;

public class ABS extends Transform {
    
    public ABS(Module parent) {
        super(parent, "ABS");
    }

	public Instance[] getTransResult(Instance[] source) {
	    
//	    System.out.println("calculating abs transform");
	    
		// The number of data instances
		final int _n = source.length;
		
		// The number of dimensions
		final int _d = source[0].getDimensionality();
		String label = source[0].getLabel();
		
		// Create storage for the results
		
		Instance[] result = new Instance[_n]; 
		
		// Perform the transformation
		for(int i=0;i<_n;i++) {
			final double[] _nextInstance = source[i].getValues();
			double[] _abs = new double[_d];
			for(int j=0;j<_d;j++) {
				_abs[j] = Math.abs(_nextInstance[j]);
			}
			result[i] = new Instance(label, _abs);
		}
		
		
		// Return results
		return result;
	}

	// This transform does not have any parameters
	public void setParameter(String name, String value) {}
}
