package hiit.plugin.activity.transform;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.utils.MathUtils;
import hiit.plugin.activity.utils.Module;

public class FFT extends Transform {

   // private ABS abs = new ABS();

    public FFT(Module parent) {
        super(parent, "FFT");
    }
    
    /**
     * Calculate the fast Fourier transform from a set of input signals.
     * 
     * @param source
     *            The input signals from which the transform is calculated.
     * @return The discrete Fourier transform of the signals.
     */
    public Instance[] getTransResult(Instance[] source) {

        // The number of data instances
        final int _n = source.length;

        // The number of dimensions
        final int _d = source[0].getDimensionality();
        String label = source[0].getLabel();

        // Create storage for the results
        double[][] _fft = new double[_n][_d];

        // Initialize the data
        for (int i = 0; i < _n; i++) {
            _fft[i] = new double[_d]; 
            //i have _no_ idea what the ft does, but it ft's the input, too. -> workaround
            System.arraycopy(source[i].getValues(), 0, _fft[i], 0, _d); 
        }
        
//        for (int i = _n; i < _fft.length; i++){
//            _fft[i] = new double[_d];
//            for (int j = 0; j < _d; j++){
//                _fft[i][j] = 0.0;
//            }
//        }

        // Return results
        _fft = MathUtils.RealFFT(_fft);
        Instance[] result = new Instance[_fft.length];

        for (int i = 0; i < source.length; i++) {
            result[i] = new Instance(label,_fft[i]);
        }

       // abs.setSource(result);
      //  result = abs.getTransform();
       
//        for (int i = 0; i < _n; i++){
//            System.out.println(source[i].getValues()[0] + "");
//        }
//
//        System.out.println("************");
//        
//        for (int i = 0; i < result.length; i++){
//            System.out.println(result[i].getValues()[0] + "");
//        }
        
        return result;
    }

    // This transform does not have any parameters
    public void setParameter(String name, String value) {
    }
}
