package hiit.plugin.activity.transform;

import hiit.plugin.activity.utils.MathUtils;
import hiit.plugin.activity.utils.Module;
import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.transform.Transform;
import hiit.plugin.activity.transform.window.*;

public class STFT extends Transform {
	
	private int _windowSize;
	private Window _window;
	private int _overLap;
    
	public STFT(Module parent) {
        super(parent, "STFT");
    }
	public Instance[] getTransResult(Instance[] source) {
		
		// Check parameters
		
		if(_windowSize <= 0 || _windowSize > source.length)
			_windowSize = source.length / 4;
		
		if(_window == null)
			_window = new RectangularWindow();
		
		if(_overLap < 0)
			_overLap = 0;
		
		if(_overLap > _windowSize) {
			if(_windowSize > 1)
				_overLap = _windowSize - 1;
			else
				_overLap = 0;
		}
				
		final int _n = source.length;
		final int _d = source[0].getDimensionality();
				
		final int _timeshift = _windowSize - _overLap;

		final int _fftSize = _windowSize * 2;
		
		final double[] _weights = _window.getWeights(_windowSize);
		
		double[][] _results = new double[_n * 2][_d];		
		
		// Loop through 
		for(int _i=0;_i<_n;) {
			
			final int _li = _i;
			final int _ui = Math.min(_n,_i + _windowSize);
			
			double[][] _tmpData = new double[_fftSize][_d];
			
			for(int _j=0;_j<(_ui - _li);_j++) {
				final double[] _nextInstance = source[_i + _j].getValues();
				for(int _k = 0;_k<_d;_k++) {
					_tmpData[_j][_k] = _nextInstance[_k] * _weights[_j];
				}
			}
			
			System.out.println(_li + ", " + _ui);
			
			_tmpData = MathUtils.FFT(_tmpData);
			
			final int _nn = _tmpData.length;
			
			// Collect results. Loop over the dimensions and the  
			// frequencies in the FFT transform and aggregate the results
			for(int _j = 0;_j < _d; _j++) {
				
				for(int _q = 0;_q<(_ui - _li);_q++) {
					
					// Current datapoint is _i + _q
					
					
				}
				
			}
			
			
			
			_i+=_timeshift;
		}
		
		/*
		
			
			
			// Apply FFT
			_tmpData = MathUtils.FFT(_tmpData);
			
			
			/*
			System.out.println("Transform: ");
			
			for(int k=0;k<_tmpData.length;k++) {
				for(int q=0;q<_tmpData[k].length;q++) {
					System.out.print(_tmpData[k][q] + "\t");
				}
				System.out.print("\n");
			}*/
			
			//_windowStartIndex++;
			
		//}
		
		return null;
		
	}

	public void setParameter(String _name, String _value) {
		
		if(_name.equalsIgnoreCase("windowsize")) {
			try {
				int _val = Integer.parseInt(_value);
				if(_val>0)
					this._windowSize = _val;
			}catch(Exception e) {}
		}else if(_name.equalsIgnoreCase("overlap")) {
			try {
				int _val = Integer.parseInt(_value);
				if(_val>0)
					this._overLap = _val;
			}catch(Exception e) {}
		}else if(_name.equalsIgnoreCase("window")){
			try {
				this._window = (Window)Class.forName(_value).newInstance();
			}
			catch(Exception e) {}
		}
		
	}

    public Instance[] getTransform() {
        // TODO Auto-generated method stub
        return null;
    }
}
