package hiit.plugin.activity.transform;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.utils.MathUtils;
import hiit.plugin.activity.utils.Module;

public class Sort extends Transform {

    public Sort(Module parent) {
        super(parent, "SORT");
    }
    public Instance[] getTransResult(Instance[] source) {

//        System.out.println("calculating sort transform");

        final int _n = source.length;
        final int _d = source[0].getDimensionality();
        String label = source[0].getLabel();

        // Create storage for the results
        double[][] _sort = new double[_n][_d];

        // Initialize the data
        for (int i = 0; i < source.length; i++) {
            _sort[i] = new double[_d]; 
            //i have _no_ idea what the sort does, but it sorts the input, too. -> workaround
            System.arraycopy(source[i].getValues(), 0, _sort[i], 0, _d); 
        }

        _sort = MathUtils._HEAPSORT(_sort);

        Instance[] result = new Instance[_sort.length];

        for (int i = 0; i < source.length; i++) {
            result[i] = new Instance(label, _sort[i]);
        }

        return result;
    }

    // This transform does not have any parameters
    public void setParameter(String name, String value) {
    }
}
