package hiit.plugin.activity.transform;

import hiit.plugin.activity.data.Data;
import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.data.Series;
import hiit.plugin.activity.utils.Module;

public abstract class Transform extends Module{
    
    protected Series result = null;
    protected Series source = null;
    
 	public static final int TRANSFORM_NONE = 0;
	public static final int TRANSFORM_ABS = 1;
	
	/**
	 * Constant indicating that the data must first be sorted.
	 */
	public static final int TRANSFORM_SORT = 2;
	
	/**
	 * Constant indicating that a fast fourier transform must be applied to the data.
	 */
	public static final int TRANSFORM_FFT = 3;	
	
	/**
	 * Constant indicating that a discrete wavelet transform must be applied to the data.
	 */
	//public static final int TRANSFORM_WAVELET = 4;	
	
	/**
	 * Constant indicating that a short time fourier transform must be applied to the data.
	 */
	//public static final int TRANSFORM_STFT = 5;
	
	public static final int TRANSFORM_XCORR = 4;
	
	public static final int NO_OF_TRANSFORMS = 5;
	
	public abstract void setParameter(String _parameterName, String _parameterValue);	

	public Transform(Module parent, String name) {
	    super(parent, name);
	}
	
	protected void resetThis() throws Exception {
        this.result = null;
    }
    
    public Data getResult() throws Exception{
        if (result != null) return result;
        result = new Series(getTransResult(((Series)parent.getResult()).getData()));
        return result;
    }
    
    protected abstract Instance[] getTransResult(Instance[] source);
}