package hiit.plugin.activity.transform;

import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.utils.Module;

public class XCorr extends Transform {

    private int mode = 0;
    
    public XCorr(Module parent) {
        super(parent, "XCORR");
    }
    public Instance[] getTransResult(Instance[] source) {
 
        // The number of data instances
        final int n = source.length;

        // The number of dimensions
        final int d = source[0].getDimensionality();
        String label = source[0].getLabel();

        // Create storage for the results

        Instance[] result = new Instance[n];

        // Perform the transformation
        for (int m = 0; m < n; m++) {
            double[] currRes = new double[d];
            for (int i = 0; i <= m; i++){
                for (int dim = 0; dim < d; dim++){
                    currRes[dim] += source[i].getValues()[dim] * source[n - m + i - 1].getValues()[dim];
                }
            }
            if (mode == 0) for (int dim = 0; dim < d; dim++){ //"unbiased" mode
                currRes[dim] /= (m + 1);
            }
            result[m] = new Instance(label, currRes);
        }

        if (mode == 1) for (int i = 0; i < n; i++){ //"coef" mode
            for (int j = 0; j < d; j++){
                result[i].getValues()[j] /= result[n - 1].getValues()[j];
            }
        }
        
/*        for (int i = 0; i < n; i++){
          
            System.out.println(source[i].getValues()[0] + "");
        }

        System.out.println("************");
        
        for (int i = 0; i < n; i++){
            System.out.println(result[i].getValues()[0] + "");
        }*/
        // Return results
        return result;
    }

    public void setParameter(String name, String value) {
        if (name == "mode"){
            if (value == "unbiased") mode = 0;
            if (value == "coef") mode = 1;
        }
    }
}
