package hiit.plugin.activity.utils;

import java.io.InputStream;

public class ResReader {

    private InputStream inputFile = null;

    public ResReader(String dataFileName) throws Exception {

        // Try to create an input stream to the appropriate resource file.
        inputFile = getClass().getResourceAsStream("/" + dataFileName);
        if (inputFile == null)
            throw new Exception("File " + dataFileName + " could not be opened");
    }

    public String readLine() throws Exception {
        
        // If the stream has been closed return null
        if (inputFile == null) return null;
        
        // Storage for the next character
        int c = -1;
        
        // The string that will contain the data. 
        String _s = "";

        // Loop until end of file
        while ((c = inputFile.read()) != -1) {
            
            // If a line break occurs, end reading
            if (c == '\n')
                break;

            // Skip unix control characters
            if (c == '\r')
                continue;

            // Append the read byte into the string
            _s += (char) c;
        }

        // If we have reached the end of file, close the file.
        if (c == -1)
            close();

        // Return results
        return _s;
    }
    
    public void close() throws Exception{
        if (inputFile != null) inputFile.close();
        inputFile = null;
    }
}
