package hiit.reader;

import hiit.blackboard.BlackboardFactory;
import hiit.blackboard.Customer;
import hiit.blackboard.CustomerData;
import hiit.blackboard.CustomerInfo;
import hiit.blackboard.event.EventData;
import hiit.connectorUnit.BTReaderFactory;
import hiit.logger.Logger;
import hiit.mapper.Properties;
import hiit.observer.Observer;

import java.io.IOException;
import java.util.Date;
import java.util.Hashtable;
import java.util.Vector;

import javax.bluetooth.BluetoothConnectionException;
import javax.microedition.io.Connection;
import javax.microedition.io.StreamConnection;

public class CounterReader extends ReaderSkeleton{

    private int count = 0;
    
    public CounterReader(){
    }
    
    public CounterReader(Connection connection, String url, Logger logger, BTReaderFactory factory, int deviceId, boolean streamMode) {
        super();
        this.delay = 100;
        this.url = url;
        this.logger = logger;
        this.factory = factory;
        this.deviceId = deviceId;
        // this.bluetoothAddress = bluetoothAddress;
        this.connection = connection;
        this.mode = streamMode;
        
        // Initialize the hash table
        initializeVariables();
        
        this.giveUp = giveUp;
    }
    
    public void initialize(Connection connection, String url, Logger logger,
            BTReaderFactory factory, int deviceId, boolean streamMode) {
    	try{
        this.url = url;
        this.logger = logger;
        this.factory = factory;
        this.deviceId = deviceId;
        // this.bluetoothAddress = bluetoothAddress;
        this.connection = connection;
        this.mode = streamMode;
        
        // Initialize the hash table
        initializeVariables();
        
        this.giveUp = false;
        this.delay = 1000;
        this.info = new CustomerInfo(getDeviceName(), deviceId, 1, this.factory.getConnector().getGatherer().getBluetoothAddress(), 
                (streamMode ? 0 : 1), delay,
                getParameterNames(), getParameterTypes(), false);
        BlackboardFactory.getBlackboard(logger).registerProducer(this, info, null);
    	}catch(Exception e){
    		e.printStackTrace();
    	}
        
        
    }
    
    public String getDeviceName() {
        return "CNTR";
    }

    protected void initializeVariables() {
        this.parameters = new Hashtable();
        this.parameters.put("Count", "0");
    }

    protected boolean readData() throws IOException {
        this.count++;
        this.parameters.put("Count", ""+this.count);
        return true;
    }

    public int[] getParameterTypes() {
        int [] types = new int[1];
        types[0] = Properties.DATATYPE_STRING;
        return types;
    }
    
    protected void notifySubscribers() {
        
        
        //Read the current data only once
        Vector[] v = new Vector[this.parameters.size()];
        Vector temp = null;
        String[] names = this.getParameterNames();
        
        for (int i = 0; i<names.length; i++){
            temp=new Vector();
            temp.addElement(this.parameters.get(names[i]));
            v[i] = temp;
        }
        
        CustomerData d = new CustomerData(v, new Date().getTime(), info);
        BlackboardFactory.getBlackboard(logger).pushData(this, d, null);
        if(this.subscribers.size()==0)return;
        
        synchronized(this) {
            long time = System.currentTimeMillis();
            for(int i=0,j=this.subscribers.size();i<j;i++) {
                if(((Long)this.lastSubscriberUpdate.elementAt(i)).longValue() + ((Long)this.timeouts.elementAt(i)).longValue() < time){
                //synchronized(this.subscribers.elementAt(i)) {
                    //Send data to the observer. Observer decides what it does with the data.
                    ((Observer)this.subscribers.elementAt(i)).update(v, this);
                    this.lastSubscriberUpdate.removeElementAt(i);
                    this.lastSubscriberUpdate.insertElementAt(new Long(time), i);
                    //Wake the observer
                    //this.subscribers.elementAt(i).notify();
                //}
                }
            }
        }       
    }


    public void newData(Customer prod, CustomerData pd, EventData eventData){
		// TODO Auto-generated method stub
		
	}

}
