package hiit.util;


import javax.bluetooth.RemoteDevice;

public class RemoteDeviceSorter {
	 
	 public static void quicksort(RemoteDevice[] a) {
        quicksort(a, 0, a.length - 1);
    }

	 public static void quicksort(RemoteDevice[] a, int left, int right) {
	        if (right <= left) return;
	        int i = partition(a, left, right);
	        quicksort(a, left, i-1);
	        quicksort(a, i+1, right);
	    }

	    // partition a[left] to a[right], assumes left < right
	    private static int partition(RemoteDevice[] a, int left, int right) {
	        int i = left - 1;
	        int j = right;
	        while (true) {
	            while (less(a[++i], a[right]))      // find item on left to swap
	                ;                               // a[right] acts as sentinel
	            while (less(a[right], a[--j]))      // find item on right to swap
	                if (j == left) break;           // don't go out-of-bounds
	            if (i >= j) break;                  // check if pointers cross
	            exch(a, i, j);                      // swap two elements into place
	        }
	        exch(a, i, right);                      // swap with partition element
	        return i;
	    }

	    // is x < y ?
	    private static boolean less(RemoteDevice x, RemoteDevice y) {
	        return x.getBluetoothAddress().compareTo(y.getBluetoothAddress()) < 0;
	    }

	    // exchange a[i] and a[j]
	    private static void exch(RemoteDevice[] a, int i, int j) {
	    	RemoteDevice swap = a[i];
	        a[i] = a[j];
	        a[j] = swap;
	    }


}
