package tester;

import hiit.plugin.activity.classifier.BoostStump;
import hiit.plugin.activity.classifier.SVM;
import hiit.plugin.activity.data.Instance;
import hiit.plugin.activity.feature.Feature;
import hiit.plugin.activity.norm.Norm_2;
import hiit.plugin.activity.utils.AccDataSource;
import hiit.plugin.activity.utils.Float11;
import hiit.plugin.activity.utils.Module;
import hiit.plugin.activity.utils.ResReader;
import hiit.plugin.activity.utils.TreeMan;
import hiit.plugin.activity.utils.Windower;

import java.util.Vector;

import utils.AccFileReader;
import utils.ArffWriter;
import utils.SvmWriter;

public class AriesTester {

    @SuppressWarnings("unchecked")
    public static void main(String[] _args) throws Exception {
        int writerMode = 0; // 0: test-mode, 1: feature-generator
        Windower windower = null;
        ArffWriter arff = null;
        SvmWriter svm = null;
        TreeMan tree = new TreeMan();
        Vector features = new Vector();

        int confusion[][] = new int[8][9];

        int human_mult = 0;
        int motor_mult = 0;
        int motor_rest = 0;

        int pos = 0;
        int neg = 0;

        // SVM human;
        // SVM motor;
        // SVM rest;

        String[] files = { "d:/newdata/ecg.andreas.csv",
                "d:/newdata/ecg.bert.csv", "d:/newdata/ecg.joni.csv",
                "d:/newdata/ecg.joonas.csv", "d:/newdata/ecg.mikael.csv",
                "d:/newdata/ecg.taneli.csv", "d:/newdata/ecg.timppa.csv",
                "d:/newdata/ecg.yiyun.csv",
                //                
                "d:/newdata/ecg.car.csv", "d:/newdata/ecg.bus.csv",
                "d:/newdata/ecg.metro.csv",
                // "d:/newdata/ecg.tram.csv",

                "d:/newdata/ecg.rest.csv", "d:/newdata/ecg.rest2.csv", };

        try {
            Module current = null;
            current = new AccFileReader(files, true);
            windower = new Windower((AccDataSource) current, new Norm_2(), 256,
                    128, 0);
            current.addChild(windower);
            tree.setRoot(windower);

            BoostStump bus = new BoostStump("bus", tree);
            BoostStump bwalk = new BoostStump("bwalk", tree);
            BoostStump car = new BoostStump("car", tree);
            BoostStump human = new BoostStump("human", tree);
            BoostStump jog = new BoostStump("jog", tree);
            BoostStump metro = new BoostStump("metro", tree);
            BoostStump motor = new BoostStump("motor", tree);
            BoostStump rest = new BoostStump("rest", tree);
            BoostStump run = new BoostStump("run", tree);
            // BoostStump tram = new BoostStump("tram", tree);
            BoostStump walk = new BoostStump("walk", tree);

            // human = new SVM("human", tree, null);
            // rest = new SVM("rest", tree, null);
            // motor = new SVM("motor", tree, null);

            // if (writerMode == 0) features = readFeatures("metro-24", tree);

            if (writerMode > 0) {
                features.add(tree.addModule("NONE.ACORR"));
                features.add(tree.addModule("NONE.AADEV"));
                features.add(tree.addModule("NONE.ENERGY"));
                features.add(tree.addModule("NONE.HMEAN"));
                features.add(tree.addModule("NONE.KURTOSIS"));
                features.add(tree.addModule("NONE.MEAN"));
                features.add(tree.addModule("NONE.MCR"));
                features.add(tree.addModule("NONE.RMS"));
                features.add(tree.addModule("NONE.SNR"));
                features.add(tree.addModule("NONE.SKEW"));
                features.add(tree.addModule("NONE.STDDEV"));
                features.add(tree.addModule("NONE.VAR"));

                features.add(tree.addModule("SORT.BSKEW"));
                features.add(tree.addModule("SORT.IQMEAN"));
                features.add(tree.addModule("SORT.IQRANGE"));
                features.add(tree.addModule("SORT.MAX"));
                features.add(tree.addModule("SORT.MEDIAN"));
                features.add(tree.addModule("SORT.MIDRANGE"));
                features.add(tree.addModule("SORT.MIN"));
                features.add(tree.addModule("SORT.PERC"));
                features.add(tree.addModule("SORT.QVC"));
                features.add(tree.addModule("SORT.RANGE"));

                //            
                //            
                // features.add(tree.addModule("FFT.ACORR", windower));
                // features.add(tree.addModule("FFT.AADEV", windower));
                // // features.add(tree.addModule("FFT.ENERGY", windower));
                // features.add(tree.addModule("FFT.HMEAN", windower));
                // features.add(tree.addModule("FFT.KURTOSIS", windower));
                // features.add(tree.addModule("FFT.MEAN", windower));
                // features.add(tree.addModule("FFT.MCR", windower));
                // // features.add(tree.addModule("FFT.RMS", windower));
                // features.add(tree.addModule("FFT.SNR", windower));
                // features.add(tree.addModule("FFT.SKEW", windower));
                // features.add(tree.addModule("FFT.STDDEV", windower));
                // features.add(tree.addModule("FFT.VAR", windower));
                // features.add(tree.addModule("FFT.MAXPOS", windower));
                // features.add(tree.addModule("FFT.SC", windower));
                //                
                //    
                // features.add(tree.addModule("FFT.SORT.BSKEW", windower));
                // features.add(tree.addModule("FFT.SORT.IQMEAN", windower));
                // features.add(tree.addModule("FFT.SORT.IQRANGE", windower));
                // //features.add(tree.addModule("FFT.SORT.MAX", windower));
                // features.add(tree.addModule("FFT.SORT.MEDIAN", windower));
                // features.add(tree.addModule("FFT.SORT.MIDRANGE", windower));
                // features.add(tree.addModule("FFT.SORT.MIN", windower));
                // features.add(tree.addModule("FFT.SORT.PERC", windower));
                // features.add(tree.addModule("FFT.SORT.QVC", windower));
                // features.add(tree.addModule("FFT.SORT.RANGE", windower));

                features.add(tree.addModule("FFT.ABS.ACORR", windower));
                features.add(tree.addModule("FFT.ABS.AADEV", windower));
                // features.add(tree.addModule("FFT.ABS.ENERGY", windower));
                features.add(tree.addModule("FFT.ABS.HMEAN", windower));
                features.add(tree.addModule("FFT.ABS.KURTOSIS", windower));
                features.add(tree.addModule("FFT.ABS.MEAN", windower));
                features.add(tree.addModule("FFT.ABS.MCR", windower));
                // features.add(tree.addModule("FFT.ABS.RMS", windower));
                features.add(tree.addModule("FFT.ABS.SNR", windower));
                features.add(tree.addModule("FFT.ABS.SKEW", windower));
                // features.add(tree.addModule("FFT.ABS.STDDEV", windower));
                // features.add(tree.addModule("FFT.ABS.VAR", windower));
                features.add(tree.addModule("FFT.ABS.MAXPOS", windower));
                features.add(tree.addModule("FFT.ABS.SC", windower));

                features.add(tree.addModule("FFT.ABS.SORT.BSKEW", windower));
                features.add(tree.addModule("FFT.ABS.SORT.IQMEAN", windower));
                features.add(tree.addModule("FFT.ABS.SORT.IQRANGE", windower));
                // features.add(tree.addModule("FFT.ABS.SORT.MAX", windower));
                features.add(tree.addModule("FFT.ABS.SORT.MEDIAN", windower));
                // features.add(tree.addModule("FFT.ABS.SORT.MIDRANGE", windower));
                features.add(tree.addModule("FFT.ABS.SORT.MIN", windower));
                features.add(tree.addModule("FFT.ABS.SORT.PERC", windower));
                features.add(tree.addModule("FFT.ABS.SORT.QVC", windower));
                // features.add(tree.addModule("FFT.ABS.SORT.RANGE", windower));
                //                
                //                
                // features.add(tree.addModule("XCORR.ACORR", windower));
                // features.add(tree.addModule("XCORR.AADEV", windower));
                // features.add(tree.addModule("XCORR.ENERGY", windower));
                // features.add(tree.addModule("XCORR.HMEAN", windower));
                // features.add(tree.addModule("XCORR.KURTOSIS", windower));
                // features.add(tree.addModule("XCORR.MEAN", windower));
                // features.add(tree.addModule("XCORR.MCR", windower));
                // features.add(tree.addModule("XCORR.RMS", windower));
                // features.add(tree.addModule("XCORR.SNR", windower));
                // features.add(tree.addModule("XCORR.SKEW", windower));
                // features.add(tree.addModule("XCORR.STDDEV", windower));
                // features.add(tree.addModule("XCORR.VAR", windower));
                //    
                // features.add(tree.addModule("XCORR.SORT.BSKEW", windower));
                // features.add(tree.addModule("XCORR.SORT.IQMEAN", windower));
                // features.add(tree.addModule("XCORR.SORT.IQRANGE", windower));
                // features.add(tree.addModule("XCORR.SORT.MAX", windower));
                // features.add(tree.addModule("XCORR.SORT.MEDIAN", windower));
                // features.add(tree.addModule("XCORR.SORT.MIDRANGE", windower));
                // features.add(tree.addModule("XCORR.SORT.MIN", windower));
                // features.add(tree.addModule("XCORR.SORT.PERC", windower));
                // features.add(tree.addModule("XCORR.SORT.QVC", windower));
                // features.add(tree.addModule("XCORR.SORT.RANGE", windower));
                //                
                //                
                // // features.add(tree.addModule("XCORR.ABS.ACORR", windower));
                // // features.add(tree.addModule("XCORR.ABS.AADEV", windower));
                // // features.add(tree.addModule("XCORR.ABS.ENERGY", windower));
                // // features.add(tree.addModule("XCORR.ABS.HMEAN", windower));
                // // features.add(tree.addModule("XCORR.ABS.KURTOSIS", windower));
                // // features.add(tree.addModule("XCORR.ABS.MEAN", windower));
                // // features.add(tree.addModule("XCORR.ABS.MCR", windower));
                // // features.add(tree.addModule("XCORR.ABS.RMS", windower));
                // // features.add(tree.addModule("XCORR.ABS.SNR", windower));
                // // features.add(tree.addModule("XCORR.ABS.SKEW", windower));
                // // features.add(tree.addModule("XCORR.ABS.STDDEV", windower));
                // // features.add(tree.addModule("XCORR.ABS.VAR", windower));
                // //
                // // features.add(tree.addModule("XCORR.ABS.SORT.BSKEW", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.IQMEAN", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.IQRANGE", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.MAX", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.MEDIAN", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.MIDRANGE", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.MIN", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.PERC", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.QVC", windower));
                // // features.add(tree.addModule("XCORR.ABS.SORT.RANGE", windower));
                //                
                //              
                // features.add(tree.addModule("XCORR.FFT.ABS.ACORR", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.AADEV", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.ENERGY", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.HMEAN", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.KURTOSIS", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.MEAN", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.MCR", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.RMS", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SNR", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SKEW", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.STDDEV", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.VAR", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.MAXPOS", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SC", windower));
                //    
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.BSKEW", windower));
                // //features.add(tree.addModule("XCORR.FFT.ABS.SORT.IQMEAN", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.IQRANGE", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.SORT.MAX", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.MEDIAN", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.SORT.MIDRANGE", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.MIN", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.PERC", windower));
                // features.add(tree.addModule("XCORR.FFT.ABS.SORT.QVC", windower));
                // // features.add(tree.addModule("XCORR.FFT.ABS.SORT.RANGE", windower));
            }
            arff = new ArffWriter("D:/features", "all.arff", 0);
            svm = new SvmWriter("D:/features", "all.svm", 0);

            int lastres = 8;

            while (true) {
                if (writerMode == 0) {
                    int num = 0;
                    int res = 8;
                    double max = -Double.MAX_VALUE;
                    if (human.classify() >= 0.0) {
                        double walkres = walk.classify();
                        double bwalkres = bwalk.classify();
                        double jogres = jog.classify();
                        double runres = run.classify();
                        if (walkres >= 0.0) {
                            num++;
                            if (lastres == 0) {
                                res = 0;
                                max = Double.MAX_VALUE;
                            }

                            if (walkres >= max) {
                                max = walkres;
                                res = 0;
                            }
                        }
                        if (bwalkres >= 0.0) {
                            num++;
                            if (lastres == 1) {
                                res = 1;
                                max = Double.MAX_VALUE;
                            }

                            if (bwalkres >= max) {
                                max = bwalkres;
                                res = 1;
                            }
                        }
                        if (jogres >= 0.0) {
                            num++;
                            if (lastres == 2) {
                                res = 2;
                                max = Double.MAX_VALUE;
                            }

                            if (jogres >= max) {
                                max = jogres;
                                res = 2;
                            }
                        }
                        if (runres >= 0.0) {
                            num++;
                            if (lastres == 3) {
                                res = 3;
                                max = Double.MAX_VALUE;
                            }

                            if (runres >= max) {
                                max = runres;
                                res = 3;
                            }
                        }
                    } else {
                        if (motor.classify() >= 0.0) {
                            double carres = car.classify();
                            double busres = bus.classify();
                            double metrores = metro.classify();

                            if (carres >= 0.0) {
                                num++;
                                if (lastres == 4) {
                                    res = 4;
                                    max = Double.MAX_VALUE;
                                }

                                if (carres >= max) {
                                    max = carres;
                                    res = 4;
                                }
                            }
                            if (busres >= 0.0) {
                                num++;
                                if (lastres == 5) {
                                    res = 5;
                                    max = Double.MAX_VALUE;
                                }

                                if (busres >= max) {
                                    max = busres;
                                    res = 5;
                                }
                            }
                            if (metrores >= 0.0) {
                                num++;
                                if (lastres == 6) {
                                    res = 6;
                                    max = Double.MAX_VALUE;
                                }

                                if (metrores >= max) {
                                    max = metrores;
                                    res = 6;
                                }
                            }
                        }
                        double restres = rest.classify();
                        if (restres >= 0.0)
                            if (restres > max || lastres == 7) {
                                res = 7;
                            }
                    }
                    // if (num < 2)
                    lastres = res;
                    confusion[classToInt(windower.getLabel())][res]++;
                    //                   
                } else {
                    Vector values = new Vector();
                    for (int i = 0; i < features.size(); i++) {
                        values
                                .add(((Instance) ((Feature) features
                                        .elementAt(i)).getResult()));
                        // System.out.println(((Instance)values.elementAt(values.size()-1)).getValues()[0]
                        // );
                    }
                    arff.addValues(values);
                    svm.addValues(values);
                }
                windower.reset();
                if (false)
                    break;
            }

        } catch (Exception e) {
            if (e.getMessage() != "EOF")
                e.printStackTrace();
        } finally {
            if (writerMode == 0) {
                // System.out.println("pos: " + pos + " // neg: " + neg);
                for (int i = 0; i < 8; i++) {
                    for (int j = 0; j < 9; j++) {
                        System.out.print(confusion[i][j] + "\t");
                    }
                    System.out.print("\n");
                }
                System.out.println();
                System.out.println("humansmult: " + human_mult
                        + " // motor_mult: " + motor_mult + " // motor_rest: "
                        + motor_rest);
                System.out.println("neg: " + neg);
                // if (windower.getClass() == Windower.class)
                // System.out.println(windower.getClass().getCanonicalName());
            } else {
                try {
                    if (writerMode == 1) {
                        arff.initFeatures(tree.getFeatureNames(features));
                        arff.writeOut();
                        arff.close();
                        // }
                        // if (writerMode == 2){
                        // svm.initFeatures("human");
                        svm.writeOut();
                        svm.close();
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }
    }

    private static Vector readFeatures(String fileName, TreeMan tree)
            throws Exception {
        ResReader reader = new ResReader(fileName + ".feats");
        String line;
        Vector feats = new Vector();
        while ((line = reader.readLine()) != null && line != "") {
            feats.addElement(tree.addModule(line));
        }
        return feats;

    }

    private static int classToInt(String className) {
        if (className.equals("walk"))
            return 0;
        if (className.equals("bwalk"))
            return 1;
        if (className.equals("jog"))
            return 2;
        if (className.equals("run"))
            return 3;
        if (className.equals("car"))
            return 4;
        if (className.equals("bus"))
            return 5;
        if (className.equals("metro"))
            return 6;
        if (className.equals("rest"))
            return 7;
        return -1;
    }
}
