package utils;

import hiit.plugin.activity.data.Instance;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Vector;

@SuppressWarnings("unchecked")
public class SvmWriter {
    private Vector<String> activities = new Vector<String>();
    private Vector values = new Vector();
    private String featureName = "";
    private String lastActivity = "";
    private int channels = 0;
    private File outFile = null;
    private FileWriter outFileWriter = null;
    private BufferedWriter outBufferedWriter = null;
    private String fileName = null;

    public SvmWriter(String path, String fileName, int channels) throws Exception {
        outFile = new File(path + "/" + fileName);
        outFileWriter = new FileWriter(outFile);
        outBufferedWriter = new BufferedWriter(outFileWriter);
        this.fileName = fileName;
        this.channels = channels;
    }

    public void addValues(Vector featureValues) throws Exception {
        if (featureValues == null || featureValues.size() == 0)
            throw new Exception("There were no featureValues to add!");
        String activity = ((Instance)featureValues.elementAt(0)).getLabel();
        if (channels == 0){
            channels = ((Instance)featureValues.elementAt(0)).getValues().length;
        }
        if(!((Instance)featureValues.elementAt(0)).valid){
            activity = "";
        }
        
        if (activity != null && !activity.equals(lastActivity)){
            lastActivity = activity;
            int index = -1;
            for (int i = 0; i < activities.size(); i++){
                if (activities.elementAt(i).equals(activity)) index = i;
            }
            if (index == -1){ 
                activities.add(activity);
            }
        }
        this.values.add(featureValues);
    }

    public void initFeatures(String featureName) {
        this.featureName = featureName;
    }

    public void writeOut() throws Exception {
        for (int j = 0; j < values.size(); j++) { // through the feature-vectors...
            Vector fVector = (Vector) values.elementAt(j);
            if (((Instance)fVector.elementAt(0)).getLabel().equals("other")) outBufferedWriter.write("-1 ");
            else outBufferedWriter.write("+1 ");
            
            for (int r = 0; r < fVector.size(); r++) { // through the current feature-vector
                Instance currInstance = (Instance)fVector.elementAt(r);
                for (int s = 0; s < channels; s++) { // through the current feature - there's
                    // one value for every data channel!
                    outBufferedWriter.write((1 + r + s*(channels - 1)) + ":" + (float)currInstance.getValues()[s] + " ");
                }
            }
            outBufferedWriter.write("\n");
            
        }
       
        values.clear();
    }

    public void close() throws Exception {
        outBufferedWriter.flush();
        outBufferedWriter.close();
        
        values = null;
        activities = null;
    }
}
